#!/usr/bin/perl -w

my $Home = $ENV{HOME};
my $User = $ENV{USER};
my $VERSION;
my $MIDI_VERS = "$Home/Library/Audio/MIDI Drivers/EmagicUSBMIDIDriver.plugin/Contents/Info.plist";
if ((-e "$Home/Library/Audio/MIDI Drivers/EmagicUSBMIDIDriver.plugin") && (-e "/Library/Audio/MIDI Drivers/EmagicUSBMIDIDriver.plugin"))

{ 	
	open(OUTPUT, ">>Library/Receipts/EmagicInstallLog.log");
	print OUTPUT "detected EmagicUSBMIDIDriver in $Home/Library/Audio/MIDI Drivers\.\ncomparing versions\.\.\.\n";
	$VERSION = GetVersion("/Library/Audio/MIDI Drivers/EmagicUSBMIDIDriver.plugin/Contents/Info.plist", "CFBundleVersion");
	if(CheckVersion("$MIDI_VERS", "$VERSION", "CFBundleVersion", "<"))
	{
		print OUTPUT "updating EmagicUSBMIDIDriver in $Home/Library/Audio/MIDI Drivers to version $VERSION\n";
		system(`rm -R "$Home/Library/Audio/MIDI Drivers/EmagicUSBMIDIDriver.plugin"`);
		system(`cp -R  "/Library/Audio/MIDI Drivers/EmagicUSBMIDIDriver.plugin"  "$Home/Library/Audio/MIDI Drivers"`);
		system(`chown -R $User "$Home/Library/Audio/MIDI Drivers/EmagicUSBMIDIDriver.plugin"`);
		
	}
	print OUTPUT "removed /Library/Audio/MIDI Drivers/EmagicUSBMIDIDriver\n\n";
	system(`rm -R "/Library/Audio/MIDI Drivers/EmagicUSBMIDIDriver.plugin"`);
	close(OUTPUT);
}

exit(0);

################################
sub CheckVersion
{
    my $path            = $_[0];
    my $version         = $_[1];
    my $keyName         = $_[2];
    my $operator        = $_[3];

    if (! -e $path) {
        return 0;
    }

    if (!$operator) {
        $operator = "==";
    }

    my $oldSeperator = $/;
    $/ = \0;

    open( PLIST, "$path") || do {
        return 0;
    };

    $plistData = <PLIST>;
    $plistData =~ /<dict>(.*?)<\/dict>/gis;

    @items = split(/<key>/, $plistData);

    shift @items;
    foreach $item (@items) {
        $item =~ /(.*?)<\/key>.*?<string>(.*?)<\/string>/gis;
        $versiondata{ $1 } = $2;
    }

    close(PLIST);

    $/ = $oldSeperator;
	my $actualVersion =  $versiondata{$keyName};

    my $expression = '$actualVersion ' . $operator . ' $version';
    if( eval ($expression) )
    {
        return 1;
    }
    else
    {
        return 0;
    }
}
####################################

sub GetVersion
{
    my $path            =$_[0];
    my $keyName         =$_[1];
    
    my $oldSeperator	= $/;
    $/ = \0;
    open(PLIST, "$path") || do 
    {
       return $!;
    };
    
    $plistData = <PLIST>;
    $plistData =~ /<dict>(.*?)<\/dict>/gis;
    
	@items = split(/<key>/, $plistData);

    shift @items;
    foreach $item (@items) 
    {
       $item =~ /(.*?)<\/key>.*?<string>(.*?)<\/string>/gs;
       $versiondata{ $1 } = $2;
    }
    close(PLIST);
   	$/ = $oldSeperator;
	my $actualVersion =  $versiondata{$keyName};
	return "$actualVersion";
}